package net.mc_pandacraft.java.plugin.pandacraftutils.commands;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import net.mc_pandacraft.java.plugin.pandacraftutils.modules.protection.SurvivalCuboManager.Cubo;
import net.mc_pandacraft.java.plugin.pandacraftutils.modules.protection.SurvivalCuboManager.StatsAchatCubo;
import net.mc_pandacraft.java.plugin.pandacraftutils.plugin_interface.EssentialsInterface;
import net.mc_pandacraft.java.plugin.pandacraftutils.plugin_interface.WorldEditInterface;
import net.mc_pandacraft.java.util.StringUtil;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.util.Vector;

import com.sk89q.worldedit.bukkit.selections.CuboidSelection;

public class CommandCubo extends AbstractCommandExecutor {
	
	public CommandCubo() {
		super("cubo");
	}

	


	@Override
	public boolean onCommand(CommandSender sender, Command command,
			String label, String[] args) {
		
		if (args.length == 0 || !(sender instanceof Player))
		{
			showHelp(sender);
			return true;
		}
		
		// la commande contient au moins un paramètre et la personne qui fait la commande est un Joueur
		Player player = (Player) sender;
		
		// on vérifie que le joueur se trouve bien dans un monde dans lequel on peut cubo
		if (!plugin.survivalCuboManager.isInCuboWorld(player.getWorld()))
		{
			player.sendMessage(ChatColor.RED+"Les cubos ne se font pas sur cette map");
			return true;
		}
		
		
		
		
		
		
		


		
		if (args[0].equalsIgnoreCase("convert"))
		{

			onCommandConvertir(player);
			
			return true;
		}
		
		
		
		
		
		
		
		
		if (args[0].equalsIgnoreCase("devis"))
		{
			CuboidSelection selection = WorldEditInterface.getPlayerCuboSelection(player);
			if (selection == null)
			{
				player.sendMessage(ChatColor.RED+"Vous devez faire une sélection WorldEdit : faites "+ChatColor.GRAY+"//wand"+ChatColor.RED+" pour avoir l'outil nécessaire");
				return true;
			}

			Player player_cubo = player;
			
			// on cherche si on traite un autre joueur
			if (plugin.survivalCuboManager.hasStaffPermission(player) && args.length >= 2) {
				Player p = plugin.getServer().getPlayerExact(args[1]);
				if (p != null && p.isOnline()) {
					player_cubo = p;
				}
				else {
					player.sendMessage(ChatColor.RED+"Le joueur que vous avez indiqué n'est pas en ligne");
					return true;
				}
			}
			
			
			onCommandDevis(player, selection, player_cubo, player_cubo.equals(player));
			
			
			return true;
		}
		
		
		
		
		
		
		
		
		
		if (args[0].equalsIgnoreCase("creer") && args.length >= 2)
		{
			
			
			CuboidSelection selection = WorldEditInterface.getPlayerCuboSelection(player);
			if (selection == null)
			{
				player.sendMessage(ChatColor.RED+"Vous devez faire une sélection WorldEdit : faites "+ChatColor.GRAY+"//wand");
				return true;
			}
			
			
			String nom_cubo = args[1];
			
			if (!nom_cubo.matches("[0-9a-zA-Z_]+"))
			{
				player.sendMessage(ChatColor.RED+"Le nom du cubo n'est pas valide : il doit contenir des lettres/chiffres et tiret du bas "+ChatColor.GRAY+"_");
				return true;
			}
			
			
			Player player_cubo = player;
			
			// on cherche si on traite un autre joueur
			if (plugin.survivalCuboManager.hasStaffPermission(player) && args.length >= 3) {
				Player p = plugin.getServer().getPlayerExact(args[2]);
				if (p != null && p.isOnline()) {
					player_cubo = p;
				}
				else {
					player.sendMessage(ChatColor.RED+"Le joueur que vous avez indiqué n'est pas en ligne");
					return true;
				}
			}
			
			
			onCommandCreer(player, selection, player_cubo, player_cubo.equals(player), nom_cubo);
			
			
			return true;
			
			
			
		}
		
		
		
		
		
		
		
		
		
		
		if (args[0].equalsIgnoreCase("liste"))
		{
			int num_page = 1;
			String player_cubo = player.getName();
			
			/*
			 * Format possible pour la commande :
			 * /cubo liste (implicitement : la page 1, pour le joueur lui-même)
			 * /cubo liste 2 (implicitement : pour le joueur lui-même)
			 * /cubo liste toto (implicitement : la page 1)
			 * /cubo liste toto 4
			 */
			
			if (args.length == 2) {
				try {
					num_page = Integer.parseInt(args[1]);
				} catch (NumberFormatException e) {
					// l'argument après "liste" n'est pas un nombre
					// on tente de le considérer comme un pseudo
					if (plugin.survivalCuboManager.hasStaffPermission(player))
						player_cubo = args[1];
					else
						player.sendMessage("Le deuxième paramètre doit être un nombre entier");
				}
			}
			if (args.length >= 3 && plugin.survivalCuboManager.hasStaffPermission(player)) {
				player_cubo = args[1];
				try {
					num_page = Integer.parseInt(args[2]);
				} catch (NumberFormatException e) {
					player.sendMessage("Le troisième paramètre doit être un nombre entier");
				}
			}
			
			
			onCommandListe(player, player_cubo, num_page);
			
			return true;
		}
		
		
		
		
		
		
		
		
		
		
		
		
		/*
		 * Dans la suite des sous-commandes, on a besoin de la protection dans le quel se trouve le joueur
		 * 
		 * Si ce cubo n'existe pas, le reste des sous-commandes n'est pas exécutable
		 */
		Cubo inside_cubo = plugin.survivalCuboManager.getCuboFromLocation(player.getLocation());
		if (inside_cubo == null)
		{
			player.sendMessage(ChatColor.RED+"Vous ne vous trouvez dans aucun cubo");
			return true;
		}
		
		
		
		
		
		
		
		

		

		if (args[0].equalsIgnoreCase("info")) {
			onCommandInfo(player, inside_cubo);
			return true;
		}
		
		
		
		
		
		
		
		

		if (args[0].equalsIgnoreCase("acheter")) {
			if (!inside_cubo.forSale()) {
				player.sendMessage(ChatColor.RED+"Ce cubo n'est pas à vendre.");
				return true;
			}
			
			if (!inside_cubo.possibleBuyer(player.getName())) {
				player.sendMessage(ChatColor.RED+"Ce cubo ne vous est pas destiné.");
				return true;
			}
			
			
			onCommandAcheter(player, inside_cubo);
			return true;
		}
		
		
		
		
		
		/*
		 * Dans la suite de la commande. Il s'agit d'appliquer des modifications sur
		 * le cubo dans lequel on se trouve. Il faut donc vérifier si on en a les droits
		 */
		
		if (!canDoActionOnCubo(inside_cubo, player))
		{
			player.sendMessage(ChatColor.RED+"Vous n'avez pas la permission de faire cette action pour ce cubo");
			return true;
		}
		
		
		
		
		
		
		
		
		
		
		if (args[0].equalsIgnoreCase("selectionner"))
		{
			WorldEditInterface.getPlugin().setSelection(player, inside_cubo.getWESelection());
			return true;
		}
		
		
		
		
		
		
		
		
		

		
		if (args[0].equalsIgnoreCase("supprimer") && args.length == 1)
		{
			onCommandSupprimer(player, inside_cubo);
			
			return true;
		}
		
		

		
		
		
		
		
		
		if (args[0].equalsIgnoreCase("ajouter") && args.length >= 2)
		{
			String new_user = args[1];
			
			if (!isValidPlayerName(new_user))
			{
				player.sendMessage(ChatColor.RED+"Le pseudo indiqué n'est pas valide");
				return true;
			}
			
			onCommandAjouter(player, inside_cubo, new_user);
			return true;
		}
		

		
		
		
		
		
		
		if (args[0].equalsIgnoreCase("enlever") && args.length >= 2)
		{
			String old_user = args[1];
			
			if (!isValidPlayerName(old_user))
			{
				player.sendMessage(ChatColor.RED+"Le pseudo indiqué n'est pas valide");
				return true;
			}
			
			onCommandEnlever(player, inside_cubo, old_user);
			return true;
		}
		
		

		
		
		
		
		if (args[0].equalsIgnoreCase("vendre") && args.length >= 2)
		{
			
			Player new_proprio = plugin.getServer().getPlayer(args[1]);
			if (new_proprio == null)
			{
				player.sendMessage(ChatColor.RED+"Le joueur indiqué n'est pas connecté");
				return true;
			}
			
			onCommandVendre(player, inside_cubo, new_proprio);
			
			return true;
		}
		
		
		
		
		
		
		
		
		
		
		// on arrive ici si aucune des sous commandes correspond à celle tapée
		sender.sendMessage(ChatColor.RED+"Mauvaise utilisation de la commande. Faites "+ChatColor.GRAY+"/cubo"+ChatColor.RED+" pour connaitre l'utilisation");
		return true;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	private void showHelp(CommandSender sender) {
		
		String[] messages = null;
		if ((sender instanceof Player) && plugin.survivalCuboManager.hasStaffPermission((Player)sender))
		{	// pour le staff connecté
			String[] m = {
					ChatColor.GOLD+"----- Assistant de protection en Survie -----",
					ChatColor.GRAY+"/cubo devis [Pseudo]"+ChatColor.GOLD+" pour calculer le prix du cubo et estimer sa faisabilité. Précisez le pseudo si ce n'est pas pour vous",
					ChatColor.GRAY+"/cubo creer <NomDuCubo> [Pseudo]"+ChatColor.GOLD+" pour créer le cubo. Précisez le pseudo si ce n'est pas pour vous",
					ChatColor.GRAY+"/cubo info"+ChatColor.GOLD+" pour afficher les infos du cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo selectionner"+ChatColor.GOLD+" pour faire une sélection WorldEdit du cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo supprimer"+ChatColor.GOLD+" pour supprimer le cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo ajouter <Pseudo>"+ChatColor.GOLD+" pour ajouter un usager dans le cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo enlever <Pseudo>"+ChatColor.GOLD+" pour enlever un usager du cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo liste [Pseudo] [Page=1]"+ChatColor.GOLD+" pour lister vos cubos. Précisez le pseudo si vous voulez lister les cubos d'un autre joueur",
					ChatColor.GRAY+"/cubo vendre <Pseudo>"+ChatColor.GOLD+" pour mettre en vente le cubo dans lequel vous êtes, en le réservant au joueur indiqué",
					ChatColor.GRAY+"/cubo acheter"+ChatColor.GOLD+" pour acheter le cubo dans lequel vous êtes. Fonctionne seulement si il est à vendre, si il est pour vous, ou si il a été à vous, avant.",
					ChatColor.GOLD+"------------------------------------------"
			};
			messages = m;
		}
		else if (sender instanceof Player)
		{	// pour les joueurs
			String[] m = {
					ChatColor.GOLD+"----- Assistant de protection en Survie -----",
					ChatColor.GRAY+"/cubo devis"+ChatColor.GOLD+" pour calculer le prix du cubo et estimer sa faisabilité",
					ChatColor.GRAY+"/cubo creer <NomDuCubo>"+ChatColor.GOLD+" pour créer le cubo si il est faisable.",
					ChatColor.GRAY+"/cubo info"+ChatColor.GOLD+" pour afficher les infos du cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo selectionner"+ChatColor.GOLD+" pour faire une sélection WorldEdit du cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo supprimer"+ChatColor.GOLD+" pour supprimer le cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo ajouter <Pseudo>"+ChatColor.GOLD+" pour ajouter un usager dans le cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo enlever <Pseudo>"+ChatColor.GOLD+" pour enlever un usager du cubo dans lequel vous êtes",
					ChatColor.GRAY+"/cubo liste [Page]"+ChatColor.GOLD+" pour lister vos cubos",
					ChatColor.GRAY+"/cubo vendre <Pseudo>"+ChatColor.GOLD+" pour mettre en vente le cubo dans lequel vous êtes, en le réservant au joueur indiqué",
					ChatColor.GRAY+"/cubo acheter"+ChatColor.GOLD+" pour acheter le cubo dans lequel vous êtes. Fonctionne seulement si il est à vendre, si il est pour vous, ou si il a été à vous, avant.",
					ChatColor.GOLD+"------------------------------------------"
			};
			messages = m;
		}
		else
		{	// pour la console et le reste (pas les joueurs)
			String[] m = {
					ChatColor.GOLD+"----- Assistant de protection en Survie -----",
					ChatColor.GOLD+"Vous devez être connecté pour exécuter les commandes de cubo",
					ChatColor.GOLD+"---------------------------------------------"
			};
			messages = m;
		}
		sender.sendMessage(messages);
	}
	

	
	
	
	
	
	

	private void onCommandDevis(Player commandSender, CuboidSelection selection, Player newOwner, boolean ownerIsCommandSender) {
		
		sendMessageToPlayers(ChatColor.GOLD+"----- Devis pour la création d'un cubo -----", commandSender, newOwner);

		if (!ownerIsCommandSender)
		{
			commandSender.sendMessage(ChatColor.GOLD+"Pour le joueur "+ChatColor.RESET+newOwner.getDisplayName());
			newOwner.sendMessage(ChatColor.GOLD+"Le devis est fait par "+ChatColor.RESET+commandSender.getDisplayName());
		}
		
		
		
		
		// vérifie si la sélection interfère avec un cubo existant
		List<String> intersected_region = plugin.survivalCuboManager.getCuboNameIntersectedBySelection(selection);
		if (intersected_region.size() > 0)
		{
			commandSender.sendMessage(ChatColor.RED+"La sélection rentre en contact avec au moins un cubo existant");
			if (commandSender != newOwner)
				newOwner.sendMessage(ChatColor.RED+"La sélection rentre en contact avec au moins un cubo existant");
			
			for(String region_name : intersected_region)
			{
				commandSender.sendMessage(ChatColor.RED+"- "+ChatColor.GRAY+region_name);
			}
		}
		
		
		// on vérifie si le joueur peut payer
		StatsAchatCubo achatCubo = plugin.survivalCuboManager.getStatsAchatCubo(selection, newOwner);
		
		sendMessageToPlayers(ChatColor.GOLD+"Prix du cubo concerné par ce devis : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.valeurCuboCree), commandSender, newOwner);

		if (achatCubo.soldeCompteApresCreation >= 0) {
			// le joueur peut payer
			if (ownerIsCommandSender) {
				commandSender.sendMessage(ChatColor.GOLD+"Votre argent avant la création du cubo : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.soldeCompteActuel));
				commandSender.sendMessage(ChatColor.GOLD+"Votre argent après la création du cubo : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.soldeCompteApresCreation));
			}
			else {
				commandSender.sendMessage(ChatColor.GOLD+"Son argent après la création du cubo : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.soldeCompteApresCreation));
				newOwner.sendMessage(ChatColor.GOLD+"Votre argent avant la création du cubo : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.soldeCompteActuel));
				newOwner.sendMessage(ChatColor.GOLD+"Votre argent après la création du cubo : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.soldeCompteApresCreation));
			}
		}
		else {
			// le joueur ne peut pas payer
			if (ownerIsCommandSender) {
				commandSender.sendMessage(ChatColor.RED+"Vous n'avez pas assez d'argent sur votre compte !");
				commandSender.sendMessage(ChatColor.RED+"Il vous manque encore : "+ChatColor.GRAY+StringUtil.formatDouble( - achatCubo.soldeCompteApresCreation));
			}
			else {
				commandSender.sendMessage(ChatColor.RED+"Le joueur n'a pas assez d'argent sur son compte !");
				commandSender.sendMessage(ChatColor.RED+"Il lui manque encore : "+ChatColor.GRAY+StringUtil.formatDouble( - achatCubo.soldeCompteApresCreation));
				newOwner.sendMessage(ChatColor.RED+"Vous n'avez pas assez d'argent sur votre compte !");
				newOwner.sendMessage(ChatColor.RED+"Il vous manque encore : "+ChatColor.GRAY+StringUtil.formatDouble( - achatCubo.soldeCompteApresCreation));
			}
		}
		
	}
	
	
	
	
	
	
	
	
	

	private void onCommandCreer(Player commandSender, CuboidSelection selection, Player newOwner, boolean ownerIsCommandSender, String cuboName) {
		
		commandSender.sendMessage(ChatColor.GOLD+"----- Création d'un cubo -----");
		if (!ownerIsCommandSender) {
			commandSender.sendMessage(ChatColor.GOLD+"Pour le joueur "+ChatColor.RESET+newOwner.getDisplayName());
		}
		
		
		
		
		// vérifie si la sélection interfère avec un cubo existant
		if (plugin.survivalCuboManager.getCuboNameIntersectedBySelection(selection).size() > 0) {
			commandSender.sendMessage(ChatColor.RED+"La protection ne peut pas se faire");
			commandSender.sendMessage(ChatColor.RED+"Faites "+ChatColor.GRAY+"/cubo devis"+ChatColor.RED+" pour plus de détails");
			return;
		}
		
		
		// on vérifie si le joueur peut payer
		StatsAchatCubo achatCubo = plugin.survivalCuboManager.getStatsAchatCubo(selection, newOwner);
				
		if (achatCubo.soldeCompteApresCreation < 0) {
			// le joueur ne peut pas payer
			commandSender.sendMessage(ChatColor.RED+"La protection ne peut pas se faire");
			commandSender.sendMessage(ChatColor.RED+"Faites "+ChatColor.GRAY+"/cubo devis"+ChatColor.RED+" pour plus de détails");
			return;
		}
		
		
		// on peut créer le cubo maintenant
		Cubo cubo = plugin.survivalCuboManager.addCubo(selection, newOwner.getName(), cuboName);

		
		
		// on retire l'argent
		EssentialsInterface.getPlayer(newOwner).setMoney(new BigDecimal(achatCubo.soldeCompteApresCreation));
		EssentialsInterface.getPlayer(newOwner).save();
		
		
		// affichage des messages de réussite
		if (!ownerIsCommandSender) {
			newOwner.sendMessage(ChatColor.GOLD+"---------- Création d'un cubo ----------");
			newOwner.sendMessage(ChatColor.GOLD+"Protection faite par "+ChatColor.RESET+commandSender.getDisplayName());
		}

		sendMessageToPlayers(ChatColor.GREEN+"Le cubo a été créé avec succès",  commandSender, newOwner);
		sendMessageToPlayers(ChatColor.GOLD+"Identifiant du cubo : "+ChatColor.GRAY+cubo.getId(),  commandSender, newOwner);
		sendMessageToPlayers(ChatColor.GOLD+"Prix du cubo : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.valeurCuboCree),  commandSender, newOwner);
		
		
		newOwner.sendMessage(ChatColor.GREEN+"L'argent est automatiquement retiré de votre compte !");
		if (commandSender != newOwner)
			commandSender.sendMessage(ChatColor.GREEN+"L'argent est automatiquement retiré du compte de "+ChatColor.RESET+newOwner.getDisplayName());
		
		
		newOwner.sendMessage(ChatColor.GOLD+"Argent qui vous reste : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.soldeCompteApresCreation));
		
		
		
	}
	
	
	
	
	
	
	
	
	
	private void onCommandListe(Player commandSender, String owner, int page) {
		List<Cubo> cubos = plugin.survivalCuboManager.getPlayerCubo(owner, commandSender.getWorld());
		
		int nb_page = (int)Math.ceil(cubos.size()/5D);
		if (page > nb_page) page = nb_page;
		if (page < 1) page = 1;
		
		commandSender.sendMessage(ChatColor.GOLD+"----- Liste des cubos de "+ChatColor.GRAY+owner+ChatColor.GOLD+" -----");
		if (cubos.size() == 0)
			commandSender.sendMessage(ChatColor.GOLD+"Aucun cubo à afficher");
		 
		for (int i=(page-1)*5; i<page*5 && i<cubos.size(); i++)
		{
			Cubo cubo = cubos.get(i);
			// TODO afficher plus d'infos sur ces cubos
			commandSender.sendMessage(ChatColor.GOLD+cubo.getId()+" : "+cubo.getVolume()+" cubes");
		}
		
		commandSender.sendMessage(ChatColor.GOLD+"Page "+page+"/"+nb_page);
	}
	
	
	
	
	
	
	
	
	
	private void onCommandInfo(Player commandSender, Cubo insideCubo) {
		Vector size = insideCubo.getSize();
		Vector midpoint = insideCubo.getMinimumPoint().getMidpoint(insideCubo.getMaximumPoint());
		
		commandSender.sendMessage(ChatColor.GOLD+"----- Information sur la protection -----");
		commandSender.sendMessage(ChatColor.GOLD+"Identifiant : "+ChatColor.GRAY+insideCubo.getId());
		commandSender.sendMessage(ChatColor.GOLD+"Dimensions : "+ChatColor.GRAY+"x="+size.getX()+" y="+size.getY()+" z="+size.getZ());
		commandSender.sendMessage(ChatColor.GOLD+"Localisation : "+ChatColor.GRAY+"x="+midpoint.getBlockX()+" y="+midpoint.getBlockY()+" z="+midpoint.getBlockZ());
		commandSender.sendMessage(ChatColor.GOLD+"Volume : "+ChatColor.GRAY+insideCubo.getVolume());
		commandSender.sendMessage(ChatColor.GOLD+"Propriétaire : "+ChatColor.GRAY+insideCubo.getOwnerName());
		commandSender.sendMessage(ChatColor.GOLD+"Usagers : "+ChatColor.GRAY+insideCubo.getUserFriendlyMembersNames());
		if (insideCubo.forSale() && insideCubo.possibleBuyer(commandSender.getName())) {
			commandSender.sendMessage(ChatColor.GOLD+"Vous avez la possibilité d'acheter ce cubo (il vous est destiné) !");
		}
	}
	
	
	
	
	
	
	
	
	
	private void onCommandSupprimer(Player commandSender, Cubo insideCubo) {

		String proprio_cubo = insideCubo.getOwnerName();
		
		
		gagnerArgentVenteCubo(insideCubo);
		plugin.survivalCuboManager.removeCubo(insideCubo);
		
		
		Player player_cubo = plugin.getServer().getPlayerExact(proprio_cubo);
		
		commandSender.sendMessage(ChatColor.GREEN+"Le cubo "+ChatColor.GRAY+insideCubo.getId()+ChatColor.GREEN+" a été supprimé");
		if (player_cubo != null && player_cubo != commandSender)
		{
			player_cubo.sendMessage(ChatColor.GREEN+"Le cubo "+ChatColor.GRAY+insideCubo.getId()+ChatColor.GREEN+" a été supprimé");
		}
		
		if (player_cubo != commandSender)
		{	// le joueur gère le cubo d'un autre joueur (en ligne ou non)
			commandSender.sendMessage(ChatColor.GREEN+"L'argent a été restauré sur le compte de "+ChatColor.GRAY+((player_cubo == null)?proprio_cubo:player_cubo.getName()));
			if (player_cubo != null)
				player_cubo.sendMessage(ChatColor.GREEN+"L'argent a été restauré sur votre compte");
		}
		else // le joueur gère son propre cubo
			commandSender.sendMessage(ChatColor.GREEN+"L'argent a été restauré sur votre compte");
		
	}
	
	
	
	
	
	
	
	
	private void onCommandAjouter(Player commandSender, Cubo insideCubo, String newMember) {

		insideCubo.addMember(newMember);

		plugin.survivalCuboManager.saveRegionManager(commandSender.getWorld());
		
		commandSender.sendMessage(ChatColor.GREEN+"Vous venez d'ajouter "+ChatColor.GRAY+newMember+ChatColor.GREEN+" dans le cubo");
		
	}
	
	
	
	
	
	
	
	
	private void onCommandEnlever(Player commandSender, Cubo insideCubo, String oldMember) {
		insideCubo.removeMember(oldMember);
		
		plugin.survivalCuboManager.saveRegionManager(commandSender.getWorld());
		
		commandSender.sendMessage(ChatColor.GREEN+"Vous venez de retirer "+ChatColor.GRAY+oldMember+ChatColor.GREEN+" du cubo");
		
	}
	
	
	
	
	
	
	
	

	private void onCommandVendre(Player commandSender, Cubo insideCubo, Player newOwner) {
		
		
		double money_win = gagnerArgentVenteCubo(insideCubo);
		
		String old_owner = insideCubo.getOwnerName();
		
		insideCubo.sellTo(newOwner.getName());

		plugin.survivalCuboManager.saveRegionManager(commandSender.getWorld());
		
		
		
		commandSender.sendMessage(ChatColor.GREEN+"Le cubo "+ChatColor.GRAY+insideCubo.getId()+ChatColor.GREEN+" a été mis en vente pour "+ChatColor.RESET+newOwner.getDisplayName());
		if (old_owner.equals(commandSender.getName()))
			commandSender.sendMessage(ChatColor.GREEN+"Vous venez de gagner "+ChatColor.GRAY+StringUtil.formatDouble(money_win));
		else
			commandSender.sendMessage(ChatColor.GRAY+old_owner+ChatColor.GREEN+" vient de gagner "+ChatColor.GRAY+StringUtil.formatDouble(money_win));
		
		
		StatsAchatCubo achatCubo = plugin.survivalCuboManager.getStatsAchatCubo(insideCubo.getWESelection(), newOwner);
		
		newOwner.sendMessage(commandSender.getDisplayName()+ChatColor.GREEN+" vient de mettre en ventre en vente le cubo "+ChatColor.GRAY+insideCubo.getId()+ChatColor.GREEN+" et vous en êtes le destinataire.");
		newOwner.sendMessage(ChatColor.GREEN+"Prix du cubo mis en vente : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.valeurCuboCree));
		newOwner.sendMessage(ChatColor.GREEN+"Si vous voulez l'acheter, mettez vous dans ce cubo et faites "+ChatColor.GRAY+"/cubo acheter");
		
	}
	
	
	
	
	
	
	
	
	private void onCommandAcheter(Player commandSender, Cubo insideCubo) {
		
		StatsAchatCubo achatCubo = plugin.survivalCuboManager.getStatsAchatCubo(insideCubo.getWESelection(), commandSender);
		if (achatCubo.soldeCompteApresCreation < 0) {
			commandSender.sendMessage(ChatColor.RED+"Vous n'avez pas assez d'argent sur votre compte !");
			commandSender.sendMessage(ChatColor.RED+"Il vous manque encore : "+ChatColor.GRAY+StringUtil.formatDouble( - achatCubo.soldeCompteApresCreation));
			return;
		}
		
		boolean ok = insideCubo.buy(commandSender.getName());
		plugin.survivalCuboManager.saveRegionManager(commandSender.getWorld());

		if (ok) {
			EssentialsInterface.getPlayer(commandSender).setMoney(new BigDecimal(achatCubo.soldeCompteApresCreation));
			EssentialsInterface.getPlayer(commandSender).save();
			
			commandSender.sendMessage(ChatColor.GREEN+"---------- Achat de cubo ----------");
			commandSender.sendMessage(ChatColor.GREEN+"Le cubo a été acheté avec succès");
			commandSender.sendMessage(ChatColor.GOLD+"Identifiant du cubo : "+ChatColor.GRAY+insideCubo.getId());
			commandSender.sendMessage(ChatColor.GOLD+"Prix du cubo : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.valeurCuboCree));
			
			commandSender.sendMessage(ChatColor.GREEN+"L'argent est automatiquement retiré de votre compte !");
			
			commandSender.sendMessage(ChatColor.GOLD+"Argent qui vous reste : "+ChatColor.GRAY+StringUtil.formatDouble(achatCubo.soldeCompteApresCreation));
			

		}
		else {
			commandSender.sendMessage(ChatColor.RED+"Ce cubo est en vente mais ne vous est pas destiné.");
		}
		
	}
	
	
	
	
	
	
	
	

	private void onCommandConvertir(Player commandSender) {
		/*
		if (!plugin.survivalCuboManager.hasStaffPermission(player))
		{
			player.sendMessage(ChatColor.RED+"Vous n'avez pas la permission de faire cette action");
			return;
		}

		plugin.getLogger().info(ChatColor.BOLD+"Conversion des protections de la map survie en cours...");
		
		List<ProtectedRegion> regions_to_convert = new ArrayList<ProtectedRegion>(wgPlugin.getRegionManager(player.getWorld()).getRegions().values());
		
		int nb_converted = 0;
		int nb_new_converted = 0;
		int nb_concerned = regions_to_convert.size();
		
		
		for (ProtectedRegion region_to_convert : regions_to_convert)
		{
			// on vérifie si c'est un cuboide (ne doit pas être un autre type de protection)
			if (!(region_to_convert instanceof ProtectedCuboidRegion))
			{
				nb_concerned--;
				continue;
			}
			
			if (region_to_convert.getPriority() < 0)
			{
				nb_concerned--;
				continue;
			}
			
			
			// on ignore les cubos dans le bon format
			if (region_to_convert.getId().matches(plugin.survivalCuboManager.regex_cubo_id))
			{
				nb_converted++;
				continue;
			}
			
			// on cherche le propriétaire
			String id = region_to_convert.getId();
			Set<String> owners = region_to_convert.getOwners().getPlayers();
			

			if (owners.size() == 0){
				plugin.getLogger().warning("cubo conversion : "+region_to_convert.getId()+" has no owner");
				continue;
			}
			
			DefaultDomain real_owners = new DefaultDomain();
			DefaultDomain real_members = new DefaultDomain();
			
			for (String p : owners)
			{
				if (id.toLowerCase().contains(p.toLowerCase()))
					real_owners.addPlayer(p);
				else
					real_members.addPlayer(p);
			}
			
			if (real_owners.size() == 0 && owners.size() == 1)
				real_owners.addPlayer(owners.toArray(new String[1])[0]);

			if (real_owners.size() == 0 && owners.size() > 1){
				plugin.getLogger().warning("cubo conversion : "+region_to_convert.getId()+" : has multiple owner but nobody is in region ID");
				continue;
			}
			if (real_owners.size() > 1){
				plugin.getLogger().warning("cubo conversion : "+region_to_convert.getId()+" : has multiple owner in region ID");
				continue;
			}
			
			String unique_owner = real_owners.getPlayers().toArray(new String[1])[0];
			String cubo_name = id.replace(unique_owner, "").trim();
			if (!cubo_name.matches("[0-9a-zA-Z_]+")){
				plugin.getLogger().warning("cubo conversion : "+region_to_convert.getId()+" : new name '"+cubo_name+"' is not a valid name");
				continue;
			}
			
			// on vérifie les intersections
			try {
				List<ProtectedRegion> regions_to_compare_with = new ArrayList<ProtectedRegion>(regions_to_convert);
				regions_to_compare_with.remove(region_to_convert);
				// on ne prends pas en compte les régions donc la priorité est négative (villes groupement de cubos)
				for (ProtectedRegion reg : regions_to_convert) {
					if (reg.getPriority() < 0)
						regions_to_compare_with.remove(reg);
				}
				int nb_inter = region_to_convert.getIntersectingRegions(regions_to_compare_with).size();
				if (nb_inter > 0)
				{
					plugin.getLogger().warning("cubo conversion : "+region_to_convert.getId()+" intersect with "+nb_inter+" other(s) regions");
					continue;
				}
			} catch (UnsupportedIntersectionException e) {
				plugin.getLogger().warning("cubo conversion : "+region_to_convert.getId()+" throw a UnsupportedIntersectionException");
				continue;
			}
			
			
			// création du cubo quiva remplacer l'ancien
			String id_cubo;
			do
				id_cubo = "cubo"+(new Random()).nextInt(1000000000)+"-"+unique_owner+"-"+cubo_name;
			while(wgPlugin.getRegionManager(player.getWorld()).hasRegion(id_cubo));
			
			ProtectedCuboidRegion new_region = new ProtectedCuboidRegion(id_cubo, region_to_convert.getMinimumPoint(), region_to_convert.getMaximumPoint());
			new_region.setMembers(real_members);
			new_region.setOwners(real_owners);
			new_region.setFlags(region_to_convert.getFlags());
			new_region.setPriority(region_to_convert.getPriority());
			
			wgPlugin.getRegionManager(player.getWorld()).removeRegion(region_to_convert.getId());
			wgPlugin.getRegionManager(player.getWorld()).addRegion(new_region);

			try {
				wgPlugin.getRegionManager(player.getWorld()).save();
			} catch (ProtectionDatabaseException e) {
				e.printStackTrace();
			}
			
			
			nb_converted++;
			nb_new_converted++;
		}
		
		plugin.getLogger().info(ChatColor.GREEN+""+nb_converted+"/"+nb_concerned+" régions converties ("+nb_new_converted+" nouvelles)");
		player.sendMessage(ChatColor.GREEN+""+nb_converted+"/"+nb_concerned+" régions converties ("+nb_new_converted+" nouvelles). Voir la console pour les régions non converties");
		// */
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	private boolean canDoActionOnCubo(Cubo c, Player p) {
		return c.isOwner(p.getName()) || plugin.survivalCuboManager.hasStaffPermission(p);
	}
	
	
	
	
	/**
	 * Envoi un message à plusieurs joueur en faisant attention qu'un joueur ne recoive pas
	 * plusieurs fois le message dans le cas où il serait référencé plusieurs fois dans les
	 * paramètres
	 * @param m le message à envoyer. IllegalArgumentException si ce paramètre est vide.
	 * @param pls les joueurs auquels il faut envoyer un message. Les joueurs null sont ignorés
	 */
	private void sendMessageToPlayers(String m, Player... pls) {
		if (m == null) throw new IllegalArgumentException("le message ne doit pas être null");
		ArrayList<Player> players = new ArrayList<Player>();
		for (Player p : pls) {
			if (p == null) continue;
			if (players.contains(p)) continue;
			p.sendMessage(m);
			players.add(p);
		}
		
	}
	
	
	
	
	private double gagnerArgentVenteCubo(Cubo c) {
		if (c.forSale()) return 0;
		double actu_money = EssentialsInterface.getPlugin().getUser(c.getOwnerName()).getMoney().doubleValue();
		
		long actu_volume_cubo = plugin.survivalCuboManager.getPlayerActualBlockCount(c.getOwnerName(), plugin.getServer().getWorld(c.getWorldName()));
		long new_volume_cubo = actu_volume_cubo - c.getVolume();
		double money_win = plugin.survivalCuboManager.getVolumePrice(actu_volume_cubo)
				- plugin.survivalCuboManager.getVolumePrice(new_volume_cubo);
		
		EssentialsInterface.getPlugin().getUser(c.getOwnerName()).setMoney(new BigDecimal(actu_money + money_win));
		
		return money_win;
	}
	
	
	

}
