package net.mc_pandacraft.java.plugin.pandacraftutils.config;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

public class CommandHistoryConfig extends AbstractConfig implements Saveable {
	
	private List<String> history;
	
	private final int nbMaxHistory = 100;

	public CommandHistoryConfig()
			throws IOException {
		super("command_history.save", FileType.FILE);
		
		history = getFileLines(true, false, false);
		
	}
	
	
	
	public synchronized String getStringList() {
		
		StringBuilder sb = new StringBuilder();
		for (String s : history) {
			sb.append(s+"\n");
		}
		sb.deleteCharAt(sb.length()-1); // pour supprimer le dernir retour à la ligne
		return sb.toString();
		
	}
	
	
	
	public synchronized void add(String s) {
		if (s == null || s.trim().equals("")) return;
		history.remove(s); // assure que l'élément ne se trouve pas déjà dans la liste
		history.add(s);
		if (history.size() > nbMaxHistory)
			history.remove(0);
	}
	
	
	
	@Override
	public synchronized void save() {
		try {
			
			PrintWriter br = new PrintWriter(configFile);
			br.print(getStringList());
			br.flush();
			br.close();
			
		} catch (Exception e) {
			warning("impossible de sauvegarder");
			e.printStackTrace();
		}
	}

}
