package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;

public class SQLManager {

	private static SQLManager instance;
	
	/**
	 * Retourne l'unique instance de la classe. Si elle n'existe pas, on tente de créer
	 * @return L'unique instance de la classe
	 */
	
	public synchronized static SQLManager getInstance() {
		if (instance == null)
			loadNewInstance();
		return instance;
	}
	
	public synchronized static void loadNewInstance() {
		instance = new SQLManager();
	}
	
	
	
	
	@SuppressWarnings("rawtypes")
	private Map<String, SQLTable> tables = new HashMap<String, SQLTable>();
	
	
	public SQLManager() {
		try {
			
			/*
			 * Les tables SQL sont à instancier ici !
			 */
			
			tables.put("modo_history", new ModoHistoryTable());
			
			
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		
	}
	
	
}
